program Bruchzahlen;

{ Selinger, 25.5.2002, fr IFB Weiterbildungslehrgang VIII }
{ Verwendung von RECORDs am Bsp. Bruchzahlen.
Aufgabe (5 Gruppen):	Prozeduren Ein-, Ausgabe, Produkt, Summe, Kuerze.
}

uses crt;

const Textfarbe = white;
      EscTaste  = chr(27);

type TBruch = record
                Zaehler, Nenner: integer;
              end;

var  Bruch1, Bruch2, Ergebnis, Eingabe: TBruch;
     Operation:        char;
     Beenden:          boolean;
     Richtige,Falsche,Anzahl: integer;

{--------------------------- Hilfsfunktionen --------------------------}

function ggt (a,b: integer): integer;

var rest: integer;
begin
  repeat
    rest := a mod b;
    a := b;
    b := rest;
  until rest = 0;
  ggt := a;
end;


function intToStr(i: integer): string;

var s: string;
begin
  str(i,s);
  intToStr := s;
end;

procedure neueZeile;

begin
  writeln;
  writeln;
  writeln;
  writeln;
  writeln;      { erzwingt Bildschirmscrolling, falls ntig }
  writeln;
  gotoXY(whereX,whereY-2);
end;

procedure piepse(ton,zeit: integer);

begin
  sound(ton);
  delay(zeit);
  nosound;
end;


function fertig: boolean;

begin
  gotoXY(45,whereY);
  textcolor(lightgray);
  write('   Weiter [Enter] oder Ende [Esc] ?');
  textcolor(Textfarbe);
  fertig := readkey = EscTaste;
end;


function Zufallsoperation: char;

begin
  case random(4) of
    0: ZufallsOperation := '+';
    1: ZufallsOperation := '-';
    2: ZufallsOperation := '*';
    3: ZufallsOperation := ':';
  end; {case}
end;


procedure schreibefarbig(farbe: integer; text: string);

begin
  textcolor(farbe);
  write(text);
  textcolor(Textfarbe);
end;



procedure kuerze (var b: TBruch);

var gT: integer;
begin
  gT := ggt(abs(b.Zaehler), abs(b.Nenner));
  b.Zaehler := b.Zaehler div gT;
  b.Nenner := b.Nenner div gT;
end;


procedure schreibeXYfarbig(x,y,farbe: integer; text: string);

var altX,altY: integer;
begin
  altX := whereX;       { alte Cursorposition speichern }
  altY := whereY;
  gotoXY(x,y);
  textcolor(farbe);
  write(text);
  gotoXY(altX,altY);
  textcolor(Textfarbe);
end;


procedure erhoeheAnzeige(var punkte: integer);

begin
  inc(punkte);
  schreibeXYfarbig(59,5,lightgreen,intToStr(Richtige));
  schreibeXYfarbig(73,5,lightred,  intToStr(Falsche ));
end;


procedure schreibeAuswertung;

begin
  textcolor(lightblue);

  writeln;
  writeln;
  writeln;
  writeln('Sie haben ',Richtige,' von ',Anzahl,' Aufgaben richtig gelst,');
  writeln('das sind ',Richtige/Anzahl*100:2:0,' Prozent. Bis zum nchsten Mal !');
  readkey;
end;


procedure erfrage (var b: TBruch);

var xpos,ypos: integer;
begin
  xpos := whereX;
  ypos := whereY;
  write(' --- ');
  gotoXY(xpos+2,ypos-1);
  readln(b.Zaehler);
  gotoXY(xpos+2,ypos+1);
  readln(b.Nenner);
  gotoXY(xpos+5,ypos);
end;


procedure schreibe (b: TBruch);

var xpos,ypos: integer;
begin
 xpos := whereX;
 ypos := whereY;
 if b.Nenner = 1 then begin
  gotoXY(xpos,ypos);
  write(b.Zaehler:3);
  gotoXY(xpos+5,ypos);
 end
 else begin
  write(' --- ');
  gotoXY(xpos,ypos-1);
  write(b.Zaehler:3);
  gotoXY(xpos,ypos+1);
  write(b.Nenner:3);
  gotoXY(xpos+5,ypos);
 end;
end;



procedure setzeZufaellig(var b: TBruch);

begin
  b.Zaehler := random(9)+1;
  b.Nenner  := random(9)+1;
end;


function gleich(b1,b2: TBruch): boolean;

begin
  gleich := (b1.Zaehler = b2.Zaehler) and (b1.Nenner = b2.Nenner);
end;


function dezimal(b: TBruch): real;

begin
  dezimal := b.Zaehler / b.Nenner;
end;


procedure addiere (b1,b2: TBruch; var erg: TBruch);

begin
  if b1.Nenner = b2.Nenner
  then begin
    erg.Zaehler := b1.Zaehler + b2.Zaehler;
    erg.Nenner := b1.Nenner;
  end
  else begin
    erg.Zaehler := b1.Nenner * b2.Zaehler + b2.Nenner * b1.Zaehler;
    erg.Nenner := b1.Nenner * b2.Nenner;
  end;
end;


procedure multipliziere (b1,b2: TBruch; var erg: TBruch);

begin
  erg.Zaehler := b1.Zaehler * b2.Zaehler;
  erg.Nenner  := b1.Nenner  * b2.Nenner;
end;

procedure kehreUm(var b: TBruch);

var z: integer;
begin
  z := b.Zaehler;
  b.Zaehler := b.Nenner;
  b.Nenner  := z;
end;

procedure dividiere (b1,b2: TBruch; var erg: TBruch);

begin
  kehreUm(b2);
  multipliziere(b1,b2,erg);
end;

procedure subtrahiere(b1,b2: TBruch; var erg: TBruch);

begin
  b2.Zaehler := -b2.Zaehler;
  addiere(b1,b2,erg);
end;


procedure berechne(b1: TBruch; op: char; b2: TBruch; var erg: TBruch);

begin
  case op of
    '+': addiere      (b1,b2,erg);
    '-': subtrahiere  (b1,b2,erg);
    '*': multipliziere(b1,b2,erg);
    ':': dividiere    (b1,b2,erg);
  end; {case}
end;


{------------------------ Hauptprogramm -----------------------}

begin
  clrscr;
  writeln;
  writeln(' Bruch-Trainer                  T.Selinger 2002');
  writeln(' ==============================================');

  schreibeXYfarbig(55,3,lightgreen,'Richtige:');
  schreibeXYfarbig(70,3,lightred  ,'Falsche:');


  Richtige := 0;
  Falsche  := 0;
  Anzahl  := 0;
  randomize;

  repeat

    neueZeile;
    inc(Anzahl);

    setzeZufaellig(Bruch1);
    schreibe(Bruch1);

    Operation := ZufallsOperation;
    write(Operation);

    setzeZufaellig(Bruch2);
    schreibe(Bruch2);

    write('=');

    berechne(Bruch1, Operation, Bruch2, Ergebnis);
    kuerze(Ergebnis);

    erfrage(Eingabe);

    if gleich(Eingabe,Ergebnis) then begin
      schreibefarbig(lightgreen, '   Richtig!');
      erhoeheAnzeige(Richtige);
    end
    else
      if dezimal(Eingabe) = dezimal(Ergebnis) then begin
        schreibefarbig(yellow, '   Unvollstndig gekrzt!');
        erhoeheAnzeige(Richtige);
      end
      else begin
        schreibefarbig(lightred, '   Falsch! Richtig wre');
        schreibe(Ergebnis);
        erhoeheAnzeige(Falsche);
        piepse(200,5000);
      end;

  until (Anzahl = 10) or fertig;

  schreibeAuswertung;
end.