program Medienliste;

uses crt;

const maxAnzahl = 10;

type TListe = record
                Element: array[1..maxAnzahl] of string;
                Anzahl:  integer;
              end;


var CDs,MCs,MP3s: TListe;
    Auswahl:      char;
    Titel:        string;
    Dateiname:    string;
    Nummer:       integer;

procedure erfrage(frage: string; var text: string);
begin
  write(frage,'? ');
  readln(text);
end;

procedure erfrageZahl(frage: string; var zahl: integer);
begin
  write(frage,'? ');
  readln(zahl);
end;

procedure schreibeFehler(text: string);
begin
  sound(100);
  delay(9000);
  nosound;
  writeln(text, '!!!');
end;


procedure zeigeMenue(text: string);
var i: integer;
begin
  writeln;
  for i:=1 to length(text) do
    if text[i]='~' then begin
      textcolor(lightred);
      inc(i);
      write(text[i]);
      textcolor(white);
    end
    else
      write(text[i]);
  writeln;
  writeln;
end;



procedure zeige(liste: TListe);
var i: integer;
begin
  if liste.Anzahl > 0 then
    for i:=1 to liste.Anzahl do
      writeln(i,'. ',liste.Element[i])
  else
    writeln('Die Liste ist leer');
end;

procedure fuegeHinzu(var liste:TListe; eintrag: string);
begin
  if liste.Anzahl < maxAnzahl then begin
    inc(liste.Anzahl);
    liste.Element[liste.Anzahl] := eintrag;
    writeln(eintrag,' hinzugefgt.');
  end
  else
    schreibeFehler('Fehler: Die Liste ist bereits voll!');
end;

procedure loesche(var liste: TListe);
begin
  liste.Anzahl := 0;
  writeln('Liste gelscht.');
end;


procedure loescheNr(var liste:Tliste; nr: integer);
var i: integer;
begin
  if (nr > 0) and (nr <= liste.Anzahl) then begin
    for i:=nr+1 to liste.Anzahl do
      liste.Element[i-1] := liste.Element[i];
    dec(liste.Anzahl);
    writeln(nr,'. Element gelscht.');
  end
  else
    schreibeFehler('Fehler: Falsche Elementnummer!');
end;

procedure oeffneDatei(var liste: TListe; dateiname: string);
var datei: file of string;
begin
  liste.Anzahl := 0;
  assign(datei,dateiname);
  reset(datei);
  while not eof(datei) do begin
    inc(liste.Anzahl);
    read(datei, liste.Element[liste.Anzahl]);
  end;
  writeln('Datei ',dateiname,' geffnet.');
end;

procedure speichereDatei(var liste: TListe; dateiname: string);
var datei: file of string;
    i:     integer;
begin
  assign(datei,dateiname);
  rewrite(datei);
  for i:=1 to liste.Anzahl do begin
    write(datei, liste.Element[i]);
  end;
  writeln('Datei ',dateiname,' gespeichert.');
end;

begin
  clrscr;
  writeln('CD-Manager');
  writeln('==========');
  zeigeMenue('~Zeige  ~Fge hinzu  ~Lsche Eintrag  Lsche ~Alles  ~ffne  ~Speichere  ~Beende');
  repeat
    Auswahl := upcase(readkey);
    case Auswahl of
      'Z': zeige(CDs);
      'A': loesche(CDs);
      'F': begin
             erfrage('Titel', Titel);
             fuegeHinzu(CDs,Titel);
           end;
      'L': begin
             erfrageZahl('Nummer',Nummer);
             loescheNr(CDs,Nummer);
           end;
      '','': begin
             erfrage('Dateiname',Dateiname);
             oeffneDatei(CDs,Dateiname);
           end;
      'S': begin
             erfrage('Dateiname',Dateiname);
             speichereDatei(CDs,Dateiname);
           end;
    end; {case}
    writeln;
  until Auswahl = 'B';
end.